         title   Split1CVCall

         .586
         .model flat, stdcall
         option casemap:none   ; Case sensitive

            include  \MASM32V1\include\Windows.inc
            include  \MASM32V1\include\user32.inc
            include  \MASM32V1\include\kernel32.inc
            include  \MASM32V1\include\gdi32.inc
            include  \MASM32V1\include\comctl32.inc
            include  \MASM32V1\include\comdlg32.inc

;       include  \MASM32V1\include\DSPMACRO.asm

         includelib  \MASM32V1\lib\user32.lib
         includelib  \MASM32V1\lib\kernel32.lib
         includelib  \MASM32V1\lib\gdi32.lib
         includelib  \MASM32V1\lib\comctl32.lib
         includelib  \MASM32V1\lib\comdlg32.lib

;===================================================
; PROTO, MACRO, and Data section
;===================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD

.const
IDM_EXIT       equ 2001

.data
ClassName      db  'SplitEC1',0
AppName        db  'SplitEC1 - Uses The Splitter32 Control',0
RichEdit       db  'RichEdit20A',0
RichEdDLL      db  'RICHED20.DLL',0
StatClass      db  'msctls_statusbar32',0
SplitClassH    db  'SplitClassH',0
;SplitClassV    db  'SplitClassV',0

LoadSplitter   db  'Splitter32.dll',0
SendHandles    db  'SetHandles',0
SendSplitters  db  'SetSplitBars',0
MenuName       db  'MainMenu',0
szNull         db  0

; Horizontal splitter
SplitH         dd  0, 119, 353, 121
SplitV         dd  0, 0, 0, 0

; Vertical splitter
;SplitH         dd  0, 0, 0, 0
;SplitV         dd  169, 0, 171, 311

.data?
hInst          dd  ?
CommandLine    dd  ?
hREdDll        dd  ?
hSplitter      dd  ?
TBHgt          dd  ?
MainExit       dd  ?
hWnd           dd  ?
MenuCnt        dd  ?

hWndStat       dd  ?
hWndChild1     dd  ?
hWndChild2     dd  ?
hSplitH        dd  ?
hSplitV        dd  ?
SplitStyle     dd  ?
sbParts        dd  4   dup(?)

;---------- [Structures] ----------

.code

;===================================================
; Program initialization section
;===================================================
start:
      INVOKE     GetModuleHandle, NULL
         mov     hInst, eax
      INVOKE     GetCommandLine
         mov     CommandLine, eax

        call     InitCommonControls

;---------- [Load the Riched20.dll] ----------
      INVOKE     LoadLibrary, addr RichEdDLL ; Load the Riched20.dll
         mov     hREdDll, eax
      .if !eax
;         INVOKE     MessageBox, NULL, addr szError1, addr szAppName, MB_OK or MB_ICONERROR
            jmp     NoGo
      .endif

      INVOKE     LoadLibrary, addr LoadSplitter
         mov     hSplitter, eax

      INVOKE     WinMain, hInst,NULL,CommandLine, SW_SHOWDEFAULT
         mov     MainExit, eax
      INVOKE     FreeLibrary, hREdDll
      INVOKE     FreeLibrary, hSplitter

NoGo:
      INVOKE     ExitProcess, MainExit

;===================================================
; WinMain procedure
;===================================================
WinMain proc  uses ebx  hinst:DWORD, hPrevInst, CmdLine, CmdShow
LOCAL    wc:WNDCLASSEX
LOCAL    msg:MSG

         mov     wc.cbSize, sizeof WNDCLASSEX
         mov     wc.style, CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
         mov     wc.lpfnWndProc, offset WndProc
         mov     wc.cbClsExtra, NULL
         mov     wc.cbWndExtra, NULL
        push     hinst
         pop     wc.hInstance
         mov     wc.hbrBackground, COLOR_BTNFACE+1
         mov     wc.lpszMenuName, offset MenuName
         mov     wc.lpszClassName, offset ClassName
      INVOKE     LoadIcon, NULL, IDI_APPLICATION
         mov     wc.hIcon, eax
         mov     wc.hIconSm, eax
      INVOKE     LoadCursor, NULL, IDC_ARROW
         mov     wc.hCursor, eax
      INVOKE     RegisterClassEx, addr wc

;---------- [Center the window] ----------
      INVOKE     GetSystemMetrics, SM_CXSCREEN
         sub     eax, 353
         shr     eax, 1
        push     eax
      INVOKE     GetSystemMetrics, SM_CYSCREEN
         sub     eax, 311
         shr     eax, 1
         pop     ebx

;---------- [Create the Main Window] ----------
      INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr ClassName,\
                 addr AppName, WS_OVERLAPPEDWINDOW,\
                 ebx, eax, 353, 311, NULL, NULL, hInst, NULL
         mov     hWnd, eax

      INVOKE     GetProcAddress, hSplitter, addr SendHandles
;      .if eax
           push     offset SplitH
           push     offset SplitStyle
           push     0
           push     hWndChild2
           push     hWndChild1
           push     hSplitH      ; If Vertical replace with 0
           push     0 ;hSplitV
           push     hWnd
           call     eax
;      .else

;      .endif

      INVOKE     ShowWindow, hWnd, SW_SHOWNORMAL
      INVOKE     UpdateWindow, hWnd

;---------- [Message loop] ----------
      .while TRUE
         INVOKE     GetMessage, addr msg, NULL, 0, 0
            .break .if (!eax)
            INVOKE     TranslateMessage, addr msg
            INVOKE     DispatchMessage, addr msg
      .endw

         mov     eax, msg.wParam
         ret
WinMain endp

;===================================================
; WinProc procedure
;===================================================
WndProc proc  hwnd:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT

;---------- [Create the Control(s) and one time stuff] ----------
      .if wMsg == WM_CREATE
            mov     TBHgt, 1

;---------- [Create the status bar window] ----------
         INVOKE     CreateWindowEx, 0, addr StatClass, 0,\
                    WS_CHILD or WS_BORDER or WS_VISIBLE or SBS_SIZEGRIP or WS_CLIPSIBLINGS,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0  
            mov     hWndStat, eax

;---------- [Splitter bar windows] ----------
;         INVOKE     CreateWindowEx, 0, addr SplitClassV, 0,\
;                    WS_CHILD or WS_VISIBLE,\
;                    0, 0, 0, 0, hwnd, 0, hInst, 0
;            mov     hSplitV, eax

         INVOKE     CreateWindowEx, 0, addr SplitClassH, 0,\
                    WS_CHILD or WS_VISIBLE,\
                    0, 0, 0, 0, hwnd, 0, hInst, 0
            mov     hSplitH, eax

;---------- [Control window] ----------
         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr RichEdit, 0,\
                    WS_CHILD or WS_VISIBLE or ES_MULTILINE or\
                    ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
                    WS_HSCROLL or ES_AUTOHSCROLL or\
                    WS_VSCROLL or ES_AUTOVSCROLL or WS_CLIPSIBLINGS,\
                    0, 0, 0, 0, hwnd, 44, hInst, 0
           test     eax, eax     
             jz     Ret0
            mov     hWndChild1, eax
         INVOKE     SendMessage, hWndChild1, EM_SETBKGNDCOLOR, 0, 00ffffe0h

         INVOKE     CreateWindowEx, WS_EX_CLIENTEDGE, addr RichEdit, 0,\
                    WS_CHILD or WS_VISIBLE or ES_MULTILINE or\
                    ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
                    WS_HSCROLL or ES_AUTOHSCROLL or\
                    WS_VSCROLL or ES_AUTOVSCROLL or WS_CLIPSIBLINGS,\
                    0, 0, 0, 0, hwnd, 45, hInst, 0
           test     eax, eax     
             jz     Ret0
            mov     hWndChild2, eax
         INVOKE     SendMessage, hWndChild2, EM_SETBKGNDCOLOR, 0, 00ffffe0h

;---------- [Move and Size the Control(s)] ----------
      .elseif wMsg == WM_SIZE

;---------- [Size the Statusbar Control] ----------
            mov     eax, lParam       ; Get width
            and     eax, 0ffffh       ; Lowword
            shr     eax, 2            ; /4
            mov     ecx, eax          ; Save factor
            mov     sbParts, eax      ; Make part 1 1/4 the width
            add     eax, ecx
            mov     [sbParts+4], eax  ; and also part2, .. etc
            add     eax, ecx
            mov     [sbParts+8], eax
            mov     [sbParts+12], -1  ; The last part extends to the end
         INVOKE     SendMessage, hWndStat, SB_SETPARTS, 4, addr sbParts
         INVOKE     MoveWindow, hWndStat, 0, 0, 0, 0, TRUE

         INVOKE     GetWindowRect, hWndStat, addr rect ; Rectangle of statusbar
            mov     eax, rect.bottom
            sub     eax, rect.top                      ; eax = height of statusbar
           push     eax
         INVOKE     GetClientRect, hWnd, addr rect
            pop     eax
            dec     eax
            sub     rect.bottom, eax

            mov     ecx, TBHgt
            add     rect.top, ecx                      ; ecx = height of toolbar if any
            mov     edx, rect.top
            mov     SplitV[4], edx
            mov     edx, rect.bottom
            sub     edx, ecx
            mov     SplitV[12], edx


;---------- [Vertical splitter bar sizing] ----------
;         INVOKE     MoveWindow, hWndChild1, 1, rect.top, SplitV, SplitV[12], FALSE
;            mov     ecx, rect.right
;            sub     ecx, SplitV[8]
;         INVOKE     MoveWindow, hWndChild2, SplitV[8], rect.top, ecx, SplitV[12], FALSE

;            mov     ecx, SplitV
;            inc     ecx
;         INVOKE     MoveWindow, hSplitV, ecx, SplitV[4], 1, SplitV[12], FALSE

;---------- [Horizontal splitter bar sizing] ----------
            mov     ecx, rect.right
            dec     ecx
            mov     SplitH[8], ecx
         INVOKE     MoveWindow, hWndChild1, 1, 1, SplitH[8], SplitH[4], FALSE
            mov     edx, rect.bottom
            sub     edx, SplitH[12]
         INVOKE     MoveWindow, hWndChild2, 1, SplitH[12], SplitH[8], edx, FALSE

            mov     ecx, SplitH[4]
            inc     ecx
         INVOKE     MoveWindow, hSplitH, SplitH, ecx, SplitH[8], 1, FALSE

;         INVOKE     InvalidateRgn, hWnd, NULL, FALSE

         INVOKE     GetProcAddress, hSplitter, addr SendSplitters
;         .if eax
              push     offset SplitH
              call     eax

;         .else

;         .endif

      .elseif wMsg == WM_NOTIFY

;---------- [System and user commands] ----------
      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
           cwde                          ; Only low word contains command
         .if eax == IDM_EXIT
            INVOKE     SendMessage, hwnd, WM_CLOSE, 0 ,0

         .endif

      .elseif wMsg == WM_CLOSE
         INVOKE     DestroyWindow, hwnd

      .elseif wMsg == WM_DESTROY
         INVOKE     PostQuitMessage, NULL

      .else

DefWin:
         INVOKE     DefWindowProc, hwnd, wMsg, wParam, lParam
            ret
      .endif

Ret0:
         xor    eax, eax
         ret
WndProc ENDP

end start
